# CONTROL.RL
# Meta-konwledge-base

TITLE Control Module of Case Based Architectural Building Planner

$INCLUDE global.dcl
$INCLUDE control.dcl

GOAL  case based architectural design over

#
RULE creating framebase
IF   FCREATE_FBASE solution name
AND  FSELECT_FBASE solution name
AND  FCREATE_FRAME Residence
AND  FADD_ATTR Residence, FSTRING, UserRequirements
AND  FADD_ATTR Residence, FDOUBLE, Rating
AND  FINSERT_VAL Residence, UserRequirements, 1, UserRequirements
AND  FINSERT_VAL Residence, Rating, 1, 63.4
AND  FINSERT_VAL Residence, Rating, 2, 87.32
AND  FINSERT_VAL Residence, Rating, 3, 100.0
THEN solution framebase is created

#
RULE case index
IF   DISPLAY stage1
AND  solution framebase is created
THEN LOAD index
AND  case index found 


#
RULE case retrieval
IF   DISPLAY stage2
THEN LOAD retriev
AND  cases retrieved

#
RULE case transformation
IF   DISPLAY stage3
THEN LOAD trans
AND  cases are transformed

#
RULE testing and validation
IF   DISPLAY stage4
THEN new solution is tested and evaluated

#
RULE storing 1
IF   task IS plan the residential building
AND  DISPLAY stage5
THEN auto save mode
AND  LOAD storer
AND  new solution is stored

#
RULE storing 2
IF   task IS store a new case in the case base
AND  DISPLAY storing
THEN LOAD storer
AND  new solution is stored

#
RULE for displaying title
IF   /* SHOW title.bmp
AND  */ DISPLAY info
THEN display title

#
RULE goal rule 1
IF   display title
AND  task IS plan the residential building
AND  case index found
AND  cases retrieved
AND  cases are transformed
AND  new solution is tested and evaluated
AND  new solution is stored
THEN case based architectural design over

#
RULE goal rule 2
IF   task IS store a new case in the case base
AND  case index found
AND  new solution is stored
THEN case based architectural design over

#
RULE goal rule 3
IF   DISPLAY Sorry
AND  solution name IS_DEFINED
THEN FDEL_FBASE solution name
AND  case based architectural design over
ELSE case based architectural design over

$INCLUDE control.inf

END
