# SETRANGE.RL
# Knowlegde-base for setting search ranges and conditions.
# rules : 29 / 00 / 01

TITLE  range and search conditions setter

$INCLUDE global.dcl
#$INCLUDE setrange.dcl

BOOLEAN search ranges and conditions are set,
        total length ranges are set,
        total depth ranges are set,
        max horizontal clearence ranges are set,
        site classes are set,
        water depth ranges are set,
        water velocity ranges are set,
        attribute ranges are set,
        conceptual design over,
        relavence ranges are set,
        very good performance ranges are set,
        good performance ranges are set,
        average performance ranges are set,
        bad performance ranges are set,
        performance ranges are set,
        relevance conditions are set,
        performance conditions are set,
        serach conditions are set

INTEGER number of sites

STRING  obstacle, attr


GOAL search ranges and conditions are set

/*
#
RULE     min and max angle of skews 1
IF       group_num IS_DEFINED  # Strictly for dependancey net
AND      FRAME(FnlRequirements, AngleOfSkew, 1) <= 15.0
THEN     min_angle_of_skew = 0.0
AND      max_angle_of_skew = 15.0

#
RULE     min and max angle of skews 2
IF       group_num IS_DEFINED  # Strictly for dependancey net
AND      FRAME(FnlRequirements, AngleOfSkew, 1) > 15.0
AND      FRAME(FnlRequirements, AngleOfSkew, 1) <= 20.0
THEN     min_angle_of_skew = 15.0
AND      max_angle_of_skew = 20.0

#
RULE     min and max angle of skews 3
IF       group_num IS_DEFINED  # Strictly for dependancey net
AND      FRAME(FnlRequirements, AngleOfSkew, 1) > 20.0
AND      FRAME(FnlRequirements, AngleOfSkew, 1) <= 25.0
THEN     min_angle_of_skew = 20.0
AND      max_angle_of_skew = 25.0

#
RULE     min and max angle of skews 4
IF       group_num IS_DEFINED  # Strictly for dependancey net
AND      FRAME(FnlRequirements, AngleOfSkew, 1) > 25.0
AND      FRAME(FnlRequirements, AngleOfSkew, 1) <= 30.0
THEN     min_angle_of_skew = 25.0
AND      max_angle_of_skew = 30.0

#
RULE     min and max angle of skews 5
IF       group_num IS_DEFINED  # Strictly for dependancey net
AND      FRAME(FnlRequirements, AngleOfSkew, 1) > 30.0
AND      FRAME(FnlRequirements, AngleOfSkew, 1) <= 33.0
THEN     min_angle_of_skew = 30.0
AND      max_angle_of_skew = 33.0

#
RULE     min and max angle of skews 6
IF       group_num IS_DEFINED  # Strictly for dependancey net
AND      FRAME(FnlRequirements, AngleOfSkew, 1) > 33.0
AND      FRAME(FnlRequirements, AngleOfSkew, 1) <= 36.0
THEN     min_angle_of_skew = 33.0
AND      max_angle_of_skew = 36.0

#
RULE     min and max angle of skews 7
IF       group_num IS_DEFINED  # Strictly for dependancey net
AND      FRAME(FnlRequirements, AngleOfSkew, 1) > 36.0
AND      FRAME(FnlRequirements, AngleOfSkew, 1) <= 39.0
THEN     min_angle_of_skew = 36.0
AND      max_angle_of_skew = 39.0

#
RULE     min and max angle of skews 8
IF       group_num IS_DEFINED  # Strictly for dependancey net
AND      FRAME(FnlRequirements, AngleOfSkew, 1) > 39.0
AND      FRAME(FnlRequirements, AngleOfSkew, 1) <= 41.0
THEN     min_angle_of_skew = 39.0
AND      max_angle_of_skew = 41.0

#
RULE     min and max angle of skews 9
IF       group_num IS_DEFINED  # Strictly for dependancey net
AND      FRAME(FnlRequirements, AngleOfSkew, 1) > 41.0
AND      FRAME(FnlRequirements, AngleOfSkew, 1) <= 43.0
THEN     min_angle_of_skew = 41.0
AND      max_angle_of_skew = 43.0

#
RULE     min and max angle of skews 10
IF       group_num IS_DEFINED  # Strictly for dependancey net
AND      FRAME(FnlRequirements, AngleOfSkew, 1) > 43.0
AND      FRAME(FnlRequirements, AngleOfSkew, 1) <= 45.0
THEN     min_angle_of_skew = 43.0
AND      max_angle_of_skew = 45.0

#
RULE     traffic_volume
IF       group_num IS_DEFINED  # Strictly for dependancey net
AND      FADD_ATTR frame, FINTEGER, traffic_volume
AND      FINSERT_VAL frame, traffic_volume, 1, FRAME(FnlRequirements, TrafficVolume, 1)            # given
AND      FINSERT_VAL frame, traffic_volume, 2, FRAME(FnlRequirements, TrafficVolume, 1) - 125  # min.
AND      FINSERT_VAL frame, traffic_volume, 3, FRAME(FnlRequirements, TrafficVolume, 1) + 125  # max.
THEN     traffic volume ranges are set

#
RULE     angle_of_skew
IF       group_num IS_DEFINED  # Strictly for dependancey net
AND      FADD_ATTR frame, FDOUBLE, angle_of_skew
AND      FINSERT_VAL frame, angle_of_skew, 1, FRAME(FnlRequirements, AngleOfSkew, 1)
AND      FINSERT_VAL frame, angle_of_skew, 2, min_angle_of_skew
AND      FINSERT_VAL frame, angle_of_skew, 3, max_angle_of_skew
THEN     angle of skew ranges are set

#
RULE     region
IF       FADD_ATTR frame, FSTRING, region
AND      FINSERT_VAL frame, region, 1, FRAME(FnlRequirements, Region, 1)     # context
AND      FINSERT_VAL frame, region, 2, FRAME(FnlRequirements, Region, 1)     # comparison
THEN     region ranges are set

#
RULE     support_settlement
IF       FADD_ATTR frame, FSTRING, support_settlement
AND      FINSERT_VAL frame, support_settlement, 1, FRAME(FnlRequirements, Settlement, 1)     # context
AND      FINSERT_VAL frame, support_settlement, 2, FRAME(FnlRequirements, Settlement, 1)     # comparison
THEN     support settlement ranges are set

#
RULE     scour_depth
IF       group_num IS_DEFINED  # Strictly for dependancey net
AND      FADD_ATTR frame, FDOUBLE, scour_depth
AND      FINSERT_VAL frame, scour_depth, 1, FRAME(Stream, ScourDepth, 1)
AND      FINSERT_VAL frame, scour_depth, 3, FRAME(Stream, ScourDepth, 1)
AND      FINSERT_VAL frame, scour_depth, 3, FRAME(Stream, ScourDepth, 1) * 1.15
THEN     scour depth ranges are set

#
RULE     attr ranges for dry obstacles and group 1
IF       group_num == 1
AND      FRAME(FnlRequirements, Obstacle, 1) IS dry
AND      FCREATE_FRAME frame
AND      FADD_ATTR frame, FINTEGER, GROUP_NUM
AND      FINSERT_VAL frame, GROUP_NUM, 1, group_num
AND      traffic volume ranges are set
AND      angle of skew ranges are set
#AND      total depth ranges are set
AND      region ranges are set
AND      support settlement ranges are set
AND      CBR_set_ranges(frame) == 1
THEN     attribute ranges are set

#
RULE     attr ranges for wet obstacles and group 1
IF       group_num == 1
AND      FRAME(FnlRequirements, Obstacle, 1) IS wet
AND      FCREATE_FRAME frame
AND      FADD_ATTR frame, FINTEGER, GROUP_NUM
AND      FINSERT_VAL frame, GROUP_NUM, 1, group_num
AND      traffic volume ranges are set
AND      angle of skew ranges are set
AND      total depth ranges are set
AND      scour depth ranges are set
AND      region ranges are set
AND      support settlement ranges are set
AND      CBR_set_ranges(frame) == 1
THEN     attribute ranges are set

#
RULE     attr ranges for dry obstacles and group 2
IF       group_num == 2
AND      FRAME(FnlRequirements, Obstacle, 1) IS dry
AND      FCREATE_FRAME frame
AND      FADD_ATTR frame, FINTEGER, GROUP_NUM
AND      FINSERT_VAL frame, GROUP_NUM, 1, group_num
AND      traffic volume ranges are set
AND      angle of skew ranges are set
#AND      total depth ranges are set
AND      CBR_set_ranges(frame) == 1
THEN     attribute ranges are set

#
RULE     attr ranges for wet obstacles and group 2
IF       group_num == 2
AND      FRAME(FnlRequirements, Obstacle, 1) IS wet
AND      FCREATE_FRAME frame
AND      FADD_ATTR frame, FINTEGER, GROUP_NUM
AND      FINSERT_VAL frame, GROUP_NUM, 1, group_num
AND      traffic volume ranges are set
AND      angle of skew ranges are set
#AND      total depth ranges are set
AND      scour depth ranges are set
AND      CBR_set_ranges(frame) == 1
THEN     attribute ranges are set

*/

# 
RULE     TotalLength
IF       FADD_ATTR frame, FDOUBLE, TotalLength
AND      FINSERT_VAL frame, TotalLength, 1, FRAME(FnlRequirements, TotalLength, 1)
AND      FINSERT_VAL frame, TotalLength, 2, FRAME(FnlRequirements, TotalLength, 1)
AND      FINSERT_VAL frame, TotalLength, 3, FRAME(FnlRequirements, TotalLength, 1) * 1.2 # 20% on higher side
THEN     total length ranges are set

# 
RULE     TotalDepth
IF       FADD_ATTR frame, FDOUBLE, TotalDepth
AND      FINSERT_VAL frame, TotalDepth, 1, FRAME(FnlRequirements,RoadFormationLevel, 1)-FRAME(SiteCrossSection,Level,1)+FRAME(FnlRequirements,DepthOfFoundation,1)
AND      FINSERT_VAL frame, TotalDepth, 2, FRAME(FnlRequirements,RoadFormationLevel, 1)-FRAME(SiteCrossSection,Level,1)+FRAME(FnlRequirements,DepthOfFoundation,1)
AND      FINSERT_VAL frame, TotalDepth, 3, (FRAME(FnlRequirements,RoadFormationLevel, 1)-FRAME(SiteCrossSection,Level,1)+FRAME(FnlRequirements,DepthOfFoundation,1)) * 1.1     # 10% on higher side
THEN     total depth ranges are set

# 
RULE     MaxHorClearance
IF       FADD_ATTR frame, FDOUBLE, MaxHorClearance
AND      FINSERT_VAL frame, MaxHorClearance, 1, FRAME(FnlRequirements, MaxHorClearence, 1)
AND      FINSERT_VAL frame, MaxHorClearance, 2, FRAME(FnlRequirements, MaxHorClearence, 1)
AND      FINSERT_VAL frame, MaxHorClearance, 3, FRAME(FnlRequirements, MaxHorClearence, 1) * 1.2     # 20% on higher side
THEN     max horizontal clearence ranges are set

#
RULE     site class is set
IF       FADD_ATTR frame, FDOUBLE, Class
AND      FINSERT_VAL frame, Class, 1, FRAME(Bridge, SiteClassIndex, 1)
AND      FINSERT_VAL frame, Class, 2, FRAME(Bridge, SiteClassIndex, 1)
AND      FINSERT_VAL frame, Class, 3, none
THEN     site classes are set

#
RULE     water depth ranges
IF       FADD_ATTR frame, FDOUBLE, WaterDepth
AND      FINSERT_VAL frame, WaterDepth, 1, FRAME(Stream, WaterDepth, 1)
AND      FINSERT_VAL frame, WaterDepth, 2, FRAME(Stream, WaterDepth, 1)
AND      FINSERT_VAL frame, WaterDepth, 3, FRAME(Stream, WaterDepth, 1) * 1.2 #the factor 1.2 may not be correct! Change it later.
THEN     water depth ranges are set

#
RULE     water velocity ranges
IF       FADD_ATTR frame, FDOUBLE, WaterVelocity
AND      FINSERT_VAL frame, WaterVelocity, 1, FRAME(Stream, StreamVelocity, 1)
AND      FINSERT_VAL frame, WaterVelocity, 2, FRAME(Stream, StreamVelocity, 1)
AND      FINSERT_VAL frame, WaterVelocity, 3, FRAME(Stream, StreamVelocity, 1) * 1.2 #the factor 1.2 may not be correct! Change it later.
THEN     water velocity ranges are set

#
RULE     setting ranges for selection 1
IF       NOT conceptual design over IS_DEFINED
AND      number of sites == 0
AND      obstacle IS dry
AND      FCREATE_FRAME frame
AND      FADD_ATTR frame, FINTEGER, GROUP_NUM
AND      FINSERT_VAL frame, GROUP_NUM, 1, 1
AND      total length ranges are set
AND      total depth ranges are set
AND      max horizontal clearence ranges are set
#AND      CBR_set_ranges (frame) == 1
THEN     attribute ranges are set

#
RULE     setting ranges for selection 2
IF       NOT conceptual design over IS_DEFINED
AND      number of sites != 0
AND      obstacle IS dry
AND      FCREATE_FRAME frame
AND      FADD_ATTR frame, FINTEGER, GROUP_NUM
AND      FINSERT_VAL frame, GROUP_NUM, 1, 1
AND      site classes are set
AND      total length ranges are set
AND      total depth ranges are set
AND      max horizontal clearence ranges are set
#AND      CBR_set_ranges(frame) == 1
THEN     attribute ranges are set

#
RULE     setting ranges for selection 3
IF       NOT conceptual design over IS_DEFINED
AND      number of sites == 0
AND      obstacle IS wet
AND      FCREATE_FRAME frame
AND      FADD_ATTR frame, FINTEGER, GROUP_NUM
AND      FINSERT_VAL frame, GROUP_NUM, 1, 1
AND      total length ranges are set
AND      total depth ranges are set
AND      max horizontal clearence ranges are set
AND      water depth ranges are set
AND      water velocity ranges are set
#AND      CBR_set_ranges(frame) == 1
THEN     attribute ranges are set

#
RULE     setting ranges for selection 4
IF       NOT conceptual design over IS_DEFINED
AND      number of sites != 0
AND      obstacle IS wet
AND      FCREATE_FRAME frame
AND      FADD_ATTR frame, FINTEGER, GROUP_NUM
AND      FINSERT_VAL frame, GROUP_NUM, 1, 1
AND      site classes are set
AND      total length ranges are set
AND      total depth ranges are set
AND      max horizontal clearence ranges are set
AND      water depth ranges are set
AND      water velocity ranges are set
#AND      CBR_set_ranges(frame) == 1
THEN     attribute ranges are set

# The ranges for relevance are same as that of selection. Therefore,
# it is enough if the group number is modified in the frame "range_data"
#
RULE     setting ranges for performance 1
IF       NOT conceptual design over IS_DEFINED
AND      number of sites == 0
AND      FMOD_POS frame, GROUP_NUM, 1, 2
#AND      CBR_set_ranges(frame) == 1
THEN     relavence ranges are set

# Only numerial attributes need to be retained
#
RULE     setting ranges for performance 2
IF       NOT conceptual design over IS_DEFINED
AND      number of sites != 0
AND      FMOD_POS frame, GROUP_NUM, 1, 2
AND      FDEL_ATTR frame, Class
#AND      CBR_set_ranges(frame) == 1
THEN     relavence ranges are set

#
RULE     very good
IF       FEXIST_FRAME frame
THEN     attr IS wtd_rating
AND      attr IS inst_name(attr, 1)
AND      FADD_ATTR frame, FDOUBLE, attr
AND      FINSERT_VAL frame, attr, 1, 80.0
AND      FINSERT_VAL frame, attr, 2, 100.0
AND      very good performance ranges are set

#
RULE     good
IF       FEXIST_FRAME frame
THEN     attr IS wtd_rating
AND      attr IS inst_name(attr, 2)
AND      FADD_ATTR frame, FDOUBLE, attr
AND      FINSERT_VAL frame, attr, 1, 60.0
AND      FINSERT_VAL frame, attr, 2, 80.0
AND      good performance ranges are set

#
RULE     average
IF       FEXIST_FRAME frame
THEN     attr IS wtd_rating
AND      attr IS inst_name(attr, 3)
AND      FADD_ATTR frame, FDOUBLE, attr
AND      FINSERT_VAL frame, attr, 1, 40.0
AND      FINSERT_VAL frame, attr, 2, 60.0
AND      average performance ranges are set

#
RULE     bad
IF       FEXIST_FRAME frame
THEN     attr IS wtd_rating
AND      attr IS inst_name(attr, 4)
AND      FADD_ATTR frame, FDOUBLE, attr
AND      FINSERT_VAL frame, attr, 1, 0.0
AND      FINSERT_VAL frame, attr, 2, 40.0
AND      bad performance ranges are set

#
RULE     performance ranges
IF       FCREATE_FRAME frame
AND      FADD_ATTR frame, FINTEGER, GROUP_NUM
AND      FINSERT_VAL frame, GROUP_NUM, 1, 3
AND      very good performance ranges are set
AND      good performance ranges are set
AND      average performance ranges are set
AND      bad performance ranges are set
#AND      CBR_set_performance_ranges(frame) == 1
THEN     performance ranges are set

#
RULE     relevance conditions
IF       CBR_set_relevance_conditions(2, 0.3, 1.0) == 1     # 0.0-0.3 time RNmax => perfect match
THEN     relevance conditions are set                       # > 0.3-1.0 time RNmax => close match

#
RULE     performance conditions
IF       CBR_set_performacne_conditions(3, 1, 1, 0, 0, 0) == 1 #very good
AND      CBR_set_performacne_conditions(3, 2, 0, 1, 0, 0) == 1 #good
AND      CBR_set_performacne_conditions(3, 3, 0, 0, 1, 0) == 1 #ave
AND      CBR_set_performacne_conditions(3, 4, 0, 0, 0, 1) == 1 #bad
THEN     performance conditions are set

#
RULE     search conditions
IF       relevance conditions are set
AND      performance conditions are set
THEN     serach conditions are set

#
RULE     goal rule 1
IF       NOT conceptual design over IS_DEFINED
AND      attribute ranges are set
AND      relavence ranges are set
AND      performance ranges are set
AND      serach conditions are set
THEN     search ranges and conditions are set
AND      LOAD control

/*
CONSTRAINTS

IF       attribute ranges are set
AND      group_num < 2  # only two groups
THEN     group_num = group_num + 1

# Here only two groups, viz  one SELECTION and one RELEVANCE are there, hence
# attribute ranges have to be set for these two groups
*/

END
