# STORER.DCL

BOOLEAN  bathroom details read
BOOLEAN  bedroom details read
BOOLEAN  bedroom instances created
BOOLEAN  bedroom dimensions are read
BOOLEAN  case card created
BOOLEAN  case information data file ready
BOOLEAN  case information stored
BOOLEAN  independent bathroom details read
BOOLEAN  independent bathroom instances created
BOOLEAN  separate bathrooms details read
BOOLEAN  solution details read
BOOLEAN  verandah information read

DOUBLE   attached bath breadth
DOUBLE   attached bath lbx
DOUBLE   attached bath lby
DOUBLE   attached bath length
DOUBLE   bed lbx
DOUBLE   bed lby
DOUBLE   building lbx
DOUBLE   building lby
DOUBLE   breadth
DOUBLE   bed room breadth
DOUBLE   bed room length
DOUBLE   independent bath breadth
DOUBLE   independent bath lbx
DOUBLE   independent bath lby
DOUBLE   independent bath length
DOUBLE   kitchen breadth
DOUBLE   kitchen lbx
DOUBLE   kitchen lby
DOUBLE   kitchen length
DOUBLE   lbx
DOUBLE   lby
DOUBLE   length
DOUBLE   verandah lbx
DOUBLE   verandah lby

STRING   attached bathroom instance
STRING   bedroom instance
STRING   case card file
STRING   case info data file
STRING   bath
STRING   frame 1 #bedroom
STRING   frame 2 #bathroom
STRING   independent bathroom instance
STRING   living dining room
STRING   parent frame

SET      case info data file   IS   cinfo.dat
SET      frame 1 IS BedRoom
SET      frame 2 IS BathRoom
SET      loop index 1 = 1 #for bed rooms
SET      loop index 2 = 1 #for independent bath rooms
SET      parent frame IS Residence
